#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <windows.h>

#include "physic_math.h"

#define POINT_TRACE

extern BODY_T bodies[];
extern void calc(void);

void Reshape(int width, int height)
{
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-3, 3, -3, 3);
	glMatrixMode(GL_MODELVIEW);

	glColor3f(1.0f, 1.0f, 1.0f);
	glLineWidth(2);

	glClear(GL_COLOR_BUFFER_BIT);

	glBegin(GL_POINTS);
		glVertex2f(bodies[0].x, bodies[0].y);
	glEnd();

	glBegin(GL_POINTS);
		glVertex2f(bodies[1].x, bodies[1].y);
	glEnd();

}

typedef struct 
{
	float x;
	float y;
	float z;
} track_t;

track_t track[10000];

int i = 0;

void Draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT);

/*
	glBegin(GL_LINES);
		glVertex2f(bodies[0].x, bodies[0].y);
		glVertex2f(bodies[2].x, bodies[2].y);
	glEnd();

	glBegin(GL_LINES);
		glVertex2f(bodies[1].x, bodies[1].y);
		glVertex2f(bodies[2].x, bodies[2].y);
	glEnd();
*/

	glBegin(GL_POINTS);
		glVertex2f(bodies[0].x, bodies[0].y);
	glEnd();

	glBegin(GL_POINTS);
		glVertex2f(bodies[1].x, bodies[1].y);
	glEnd();

	glBegin(GL_POINTS);
		glVertex2f(bodies[2].x, bodies[2].y);
	glEnd();
	
	glFlush();
	Sleep(1);
	glutPostRedisplay();
}

DWORD ThreadProc(LPVOID lpdwThreadParam)
{
	while(1)
	{
		calc();
		
		track[i%10000].x = bodies[2].x;
		track[i%10000].y = bodies[2].y;
		track[i%10000].z = bodies[2].z;
		
		Sleep(1);
		glutPostRedisplay();
		
		i++;
	}
	return 0;
}


int main(int argc, char *argv[])
{
	DWORD dwThreadId;
	HANDLE hThread;
	
	memset(track, 0x00, sizeof(track));

	glutInit(&argc, argv);
	glutInitWindowSize(600, 600);
	glutInitWindowPosition(100, 100);

	glutInitDisplayMode(GLUT_RGB);
	glutCreateWindow("Demo");
	
	if ((hThread = CreateThread(NULL, 	0, (LPTHREAD_START_ROUTINE)&ThreadProc, NULL /*(LPVOID)&i*/, 0, &dwThreadId)) == NULL)
	{
		return 1;
	}
	
	glutReshapeFunc(Reshape);
	glutDisplayFunc(Draw);
	glClearColor(0, 0, 0, 0);

	glutMainLoop();
	
	TerminateThread(hThread, 0);
	return 0;
}
