#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

#include "physic_math.h"

/*
#define NUM_POINTS	3
#define DELTA_T		0.01
#define K_NORM      0.003

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,     100.0,     0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,     120.0,    -0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,      0.1,     0.3,  1.0,  0.0,    -0.8,  0.0,  0.0 },
};
*/

/*
// pic02

#define NUM_POINTS      3
#define DELTA_T         0.01
#define K_NORM          0.003

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,     100.0,     0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,     120.0,    -0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,      0.1,     0.3,  2.0,  0.0,    -0.12, 0.0,  0.0 },
};
*/

/*
#define NUM_POINTS      3
#define DELTA_T         0.01
#define K_NORM          0.005

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,     100.0,     0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,       0.1,    -0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,     10.1,     1.0,  2.0,  0.0,     -0.4,  0.0,  0.0 },
};
*/

/*
#define NUM_POINTS      3
#define DELTA_T         0.1
#define K_NORM          0.003

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,     100.0,     0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,       0.1,    -0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,     10.1,     1.0,  2.0,  0.0,     -0.4,  0.0,  0.0 },
};
*/

#define NUM_POINTS      3
#define DELTA_T         0.1
#define K_NORM          0.003

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,     100.0,     0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,       0.1,    -0.8,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,     10.1,     1.0,  2.0,  0.0,     -0.4,  0.0,  0.0 },
};


/*
#define NUM_POINTS	3
#define DELTA_T		0.01
#define K_NORM      0.0001

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,    10000.0,     0.0,  0.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,       1.0,     2.0,  0.0,  0.0,     0.0,  0.5,  0.0 },
	{ TYPE_DYNAMIC,       0.01,    1.0,  0.0,  0.0,     0.0,  0.1,  0.0 },
};
*/

/*
#define NUM_POINTS	5
#define DELTA_T		0.01
#define K_NORM      0.0001

BODY_T bodies[NUM_POINTS] = 
{
	{ TYPE_STATIC,    10000.0,    -1.0, -1.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,    10000.0,     1.0, -1.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,    10000.0,    -1.0,  1.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_STATIC,    10000.0,     1.0,  1.0,  0.0,     0.0,  0.0,  0.0 },
	{ TYPE_DYNAMIC,       1.0,     2.0,  2.0,  0.0,    -0.3,  0.2,  0.0 },
};
*/

void calc(void)
{
	int i, j;
	
	//    . 
	//  ,    .
	
	for (i = 0; i < NUM_POINTS; i++)
	{
		for (j = 0; j < NUM_POINTS; j++)
		{
			if (i == j) 
				continue;
			
			if (bodies[i].type == TYPE_STATIC)
				continue;
			
			if (bodies[i].type == TYPE_DYNAMIC)
			{
				float up_tmp;
				float L_x, L_y, L_z;
				float L2;
				float F_x, F_y, F_z;
				float F;
				
				up_tmp = K_NORM * bodies[i].m * bodies[j].m;
				
				L_x = bodies[j].x - bodies[i].x;
				L_y = bodies[j].y - bodies[i].y;
				L_z = bodies[j].z - bodies[i].z;
				L2 = SQR(L_x) + SQR(L_y) + SQR(L_z);
				if (L2 == 0.0)
				{
					//printf("L2 == 0.0\r\n");
					continue;
				}
				
				F   = up_tmp / L2;
				F_x = L_x * (F / sqrt(L2));
				F_y = L_y * (F / sqrt(L2));
				F_z = L_z * (F / sqrt(L2)); 
				
//				bodies[i].speed_x_prev = bodies[i].speed_x;
//				bodies[i].speed_y_prev = bodies[i].speed_y;
//				bodies[i].speed_z_prev = bodies[i].speed_z;
				
				bodies[i].speed_x += F_x / bodies[i].m * DELTA_T;
				bodies[i].speed_y += F_y / bodies[i].m * DELTA_T;
				bodies[i].speed_z += F_z / bodies[i].m * DELTA_T;
			}
		}
	}

	for (i = 0; i < NUM_POINTS; i++)
	{
		if (bodies[i].type == TYPE_DYNAMIC)
		{
//			bodies[i].x += (bodies[i].speed_x + bodies[i].speed_x_prev) / 2 * DELTA_T;
//			bodies[i].y += (bodies[i].speed_y + bodies[i].speed_y_prev) / 2 * DELTA_T;
//			bodies[i].z += (bodies[i].speed_z + bodies[i].speed_z_prev) / 2 * DELTA_T;

			bodies[i].x += bodies[i].speed_x * DELTA_T;
			bodies[i].y += bodies[i].speed_y * DELTA_T;
			bodies[i].z += bodies[i].speed_z * DELTA_T;
		}
	}
}

#if !defined( GUI )
int main(void)
{
	while (1)
	{
		Sleep(20);
		calc();
		printf("SPEED:(%f, %f) POS:(%f, %f) \r\n", 
			bodies[2].speed_x, bodies[2].speed_y, 
			bodies[2].x,       bodies[2].y);
	}
}
#endif // !GUI
